> ## Documentation Index
> Fetch the complete documentation index at: https://developer.sandbox.co.in/llms.txt
> Use this file to discover all available pages before exploring further.

# Cash Ledger

> Get Cash Ledger for the specified period for authenticated taxpayer

#### Response schema

For successful responses, these resources describe the GSTN payload at `data.data`.

<Card title="View JSON schema" icon="code" href="https://raw.githubusercontent.com/in-co-sandbox/in-co-sandbox-docs/refs/heads/main/data/gst/schema/request/taxpayer/ledgers/cash_ledger.json" arrow="true" horizontal />

<Card title="View Excel field reference" icon="file-spreadsheet" href="https://raw.githubusercontent.com/in-co-sandbox/in-co-sandbox-docs/refs/heads/main/data/gst/schema/workbook/taxpayer/ledgers/cash_ledger-v0.3.xlsx" arrow="true" horizontal />


## OpenAPI

````yaml api-reference/gst/compliance/openapi.json GET /gst/compliance/tax-payer/ledgers/cash
openapi: 3.0.1
info:
  title: compliance
  description: >-
    **GST Compliance API** enables businesses to automate compliance
    requirements like [Taxpayer
    verification](https://developer.sandbox.co.in/reference/search-gstin-api),
    [GSTR
    Filing](https://developer.sandbox.co.in/reference/gst-taxpayer-authentication),
    [Generating
    E-Invoices](https://developer.sandbox.co.in/reference/e-invoice-authentication-api),
    and [E-Way
    Bills](https://developer.sandbox.co.in/reference/e-way-bill-authentication-api).We
    provide these APIs from GSTN-authorised GST Suvidha Providers, handling the
    encryption-decryption and signing so you don't have to handle the
    complexities.
  version: 1.0.0
servers:
  - url: https://api.sandbox.co.in
  - url: https://test-api.sandbox.co.in
security: []
tags:
  - name: Public
  - name: Taxpayer
  - name: Taxpayer Auth
  - name: Returns
  - name: GSTR-1 Documents
  - name: File GSTR-1
  - name: GSTR-2A Documents
  - name: GSTR-2B Document
  - name: File GSTR-3B
  - name: GSTR-4
  - name: File GSTR-9
  - name: Invoice Management System
  - name: GSTR-1A Documents
  - name: File GSTR-1A
  - name: Ledgers
  - name: e-Invoice
  - name: Sales e-Invoices for return period
  - name: Purchase e-Invoices for return period
  - name: Front Office Notices
  - name: Front Office
  - name: AATO
  - name: e-Invoice1
  - name: Authentication
  - name: e-Invoice12
  - name: E-Way Bill
  - name: E-Way Bill1
  - name: Authentication1
  - name: Consignor
  - name: Consolidated E-Way Bill
  - name: Multi-Vehicle Movement
  - name: Consignee
  - name: Transporter
  - name: Consolidated E-Way Bill1
  - name: Multi-vehicle Movement
  - name: Common
paths:
  /gst/compliance/tax-payer/ledgers/cash:
    get:
      tags:
        - Taxpayer
        - Ledgers
      summary: Cash Ledger
      description: Get Cash Ledger for the specified period for authenticated taxpayer
      operationId: getCashLedger
      parameters:
        - name: to
          in: query
          description: '`required` To Date (DD/MM/YYYY)'
          required: false
          schema:
            type: string
            example: '{{to_date}}'
        - name: from
          in: query
          description: From Date (DD/MM/YYYY)
          required: false
          schema:
            type: string
            example: '{{from_date}}'
        - name: authorization
          in: header
          description: >-
            GST taxpayer access token. For token-generation steps, refer to the
            [Generate Taxpayer
            Session](/recipes/gst/authentication/generate_tax_payer_session)
            recipe, then pass the token in the authorization header.
          required: true
          example: ''
          schema:
            type: string
        - name: x-api-key
          in: header
          description: API key for identification
          required: true
          example: ''
          schema:
            type: string
        - name: x-api-version
          in: header
          description: API version
          required: false
          example: ''
          schema:
            type: string
            default: 1.0.0
      responses:
        '200':
          description: LG9089 To date cannot be beyond the current date / 200 Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetCashLedgerResponse'
              examples:
                200 Success:
                  summary: 200 Success
                  value:
                    code: 200
                    data:
                      status_cd: '1'
                      data:
                        cl_bal:
                          cessbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          cgstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          desc: Closing Balance
                          igstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          sgstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          tot_rng_bal: 0
                        fr_dt: 01/04/2024
                        gstin: 24AAACQ3770E1ZP
                        op_bal:
                          cessbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          cgstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          desc: Opening Balance
                          igstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          sgstbal:
                            fee: 0
                            intr: 0
                            oth: 0
                            pen: 0
                            tot: 0
                            tx: 0
                          tot_rng_bal: 0
                        to_dt: 11/04/2024
                        tr: []
                    timestamp: 1763446641000
                    transaction_id: 01459da0-b84b-4aab-9867-bb84e8c67348
                LG9089 To date cannot be beyond the current date:
                  summary: LG9089 To date cannot be beyond the current date
                  value:
                    code: 200
                    data:
                      status_cd: '0'
                      error:
                        error_cd: LG9089
                        message: To Date cannot be beyond the current date
                    timestamp: 1763446641000
                    transaction_id: 6fd2b813-bc69-40cf-a033-2d4f319ef728
          headers: {}
      deprecated: false
      security: []
components:
  schemas:
    GetCashLedgerResponse:
      oneOf:
        - $ref: '#/components/schemas/GetCashLedgerSuccessResponse'
        - $ref: '#/components/schemas/GstnBusinessErrorResponse'
      description: >-
        A GSTN success or GSTN business-failure response. Both variants use HTTP
        200.
    GetCashLedgerSuccessResponse:
      allOf:
        - $ref: '#/components/schemas/TaxpayerResponseMetadata'
        - type: object
          required:
            - data
          properties:
            data:
              type: object
              description: The GSTN success wrapper.
              required:
                - status_cd
                - data
              properties:
                status_cd:
                  type: string
                  enum:
                    - '1'
                  description: GSTN success status.
                  example: '1'
                data:
                  $ref: '#/components/schemas/GetCashLedgerSuccessPayload'
    GstnBusinessErrorResponse:
      type: object
      description: HTTP 200 response containing a GSTN business failure.
      required:
        - code
        - timestamp
        - transaction_id
        - data
      properties:
        code:
          type: integer
          description: The HTTP status code reported in the response body.
          enum:
            - 200
          example: 200
        timestamp:
          type: integer
          format: int64
          description: The response timestamp in Unix epoch milliseconds.
          example: 1763446641000
        transaction_id:
          type: string
          description: The transaction identifier used to trace the request.
          example: 41bb8041-fb83-4654-8d75-85a19f329158
        data:
          type: object
          description: The GSTN business-failure wrapper.
          required:
            - status_cd
            - error
          properties:
            status_cd:
              type: string
              enum:
                - '0'
              description: GSTN business-failure status.
              example: '0'
            error:
              $ref: '#/components/schemas/GstnBusinessError'
    TaxpayerResponseMetadata:
      type: object
      description: Fields included in every taxpayer endpoint response.
      required:
        - code
        - timestamp
        - transaction_id
      properties:
        code:
          type: integer
          description: The HTTP status code reported in the response body.
          enum:
            - 200
          example: 200
        timestamp:
          type: integer
          format: int64
          description: The response timestamp in Unix epoch milliseconds.
          example: 1763446641000
        transaction_id:
          type: string
          description: The transaction identifier used to trace the request.
          example: 41bb8041-fb83-4654-8d75-85a19f329158
    GetCashLedgerSuccessPayload:
      type: object
      description: Successful GSTN payload for Get Cash Ledger.
      properties:
        gstin:
          type: string
          description: GSTIN
          minLength: 15
          maxLength: 15
        fr_dt:
          description: from date
          type: string
        to_dt:
          description: to date
          type: string
        op_bal:
          type: object
          description: Opening Balance
          properties:
            desc:
              type: string
              description: description about opening balance
            tot_rng_bal:
              description: total opening balance
              type: number
            igst:
              type: object
              description: IGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total igst balance
                  type: number
            cgst:
              type: object
              description: CGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total cgst balance
                  type: number
            sgst:
              type: object
              description: SGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total sgst balance
                  type: number
            cess:
              type: object
              description: CESS
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total cess balance
                  type: number
            cessbal:
              type: object
              description: The cessbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            cgstbal:
              type: object
              description: The cgstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            igstbal:
              type: object
              description: The igstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            sgstbal:
              type: object
              description: The sgstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
        tr:
          type: array
          description: The tr value returned by GSTN.
          items:
            type: object
            description: A GSTN record whose fields vary by return section.
            properties:
              dpt_dt:
                description: deposited date
                type: string
              rpt_dt:
                description: reporting date
                type: string
              desc:
                type: string
                description: Transaction description
              dpt_time:
                type: string
                description: deposit time stamp
              ref_no:
                type: string
                description: Reference number
              tot_tr_amt:
                type: number
                description: total Transaction amount
              tot_rng_bal:
                type: number
                description: total transaction  balance
              ret_period:
                type: string
                description: Return Period
              tr_typ:
                type: string
                description: Transaction Type to specify credit or debit
              igst:
                type: object
                description: IGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              cgst:
                type: object
                description: CGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              sgst:
                type: object
                description: SGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              cess:
                type: object
                description: CESS
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              igstbal:
                type: object
                description: IGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              cgstbal:
                type: object
                description: CGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              sgstbal:
                type: object
                description: SGST
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
              cessbal:
                type: object
                description: CESS
                properties:
                  tx:
                    description: tax
                    type: number
                  intr:
                    description: interest
                    type: number
                  pen:
                    description: penalty
                    type: number
                  oth:
                    description: others
                    type: number
                  fee:
                    description: fee
                    type: number
                  tot:
                    description: total
                    type: number
        cl_bal:
          type: object
          description: Closing Balance
          properties:
            desc:
              type: string
              description: description about Closing balance
            tot_rng_bal:
              description: total closing balance
              type: number
            igst:
              type: object
              description: IGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total igst balance
                  type: number
            cgst:
              type: object
              description: CGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total cgst balance
                  type: number
            sgst:
              type: object
              description: SGST
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total sgst balance
                  type: number
            cess:
              type: object
              description: CESS
              properties:
                tx:
                  description: tax balance
                  type: number
                intr:
                  description: interest balance
                  type: number
                pen:
                  description: penalty balance
                  type: number
                oth:
                  description: others balance
                  type: number
                fee:
                  description: fee balance
                  type: number
                tot:
                  description: total cess balance
                  type: number
            cessbal:
              type: object
              description: The cessbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            cgstbal:
              type: object
              description: The cgstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            igstbal:
              type: object
              description: The igstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
            sgstbal:
              type: object
              description: The sgstbal value returned by GSTN.
              properties:
                fee:
                  type: number
                  description: The fee value returned by GSTN.
                  example: 0
                intr:
                  type: number
                  description: The intr value returned by GSTN.
                  example: 0
                oth:
                  type: number
                  description: The oth value returned by GSTN.
                  example: 0
                pen:
                  type: number
                  description: The pen value returned by GSTN.
                  example: 0
                tot:
                  type: number
                  description: The tot value returned by GSTN.
                  example: 0
                tx:
                  type: number
                  description: The tx value returned by GSTN.
                  example: 0
    GstnBusinessError:
      type: object
      description: A business error returned by GSTN.
      required:
        - error_cd
        - message
      properties:
        error_cd:
          type: string
          description: The GSTN business error code.
          example: RET11416
        message:
          type: string
          description: A human-readable description of the GSTN business error.
          example: No records found.

````